#include <windows.h>
#include <windowsx.h>
#include <tchar.h>
#include "resource.h"
#include "defblib.h"
#include "resize.h"
#include "resize2.h"

BOOL CALLBACK resizeDlgProc(
    HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam )
{
    static CtlInfo g_aCtlInfo[] = {
        { IDC_COMBO        , right, none   },
        { IDC_EDIT         , right, bottom },
        { IDC_SCROLLBAR    , right, both   },
        { IDOK             , both , none   },
        { IDCANCEL         , both , none   },
        { IDC_STATIC_TEXT  , both , both   },
        { IDC_HELP_BUTTON  , both , both   },
    };
    
    static Resizer g_resizer = {
        sizeof g_aCtlInfo / sizeof g_aCtlInfo[ 0 ], g_aCtlInfo,
    };
    
    const int id   = GET_WM_COMMAND_ID ( wParam, lParam );
    const int code = GET_WM_COMMAND_CMD( wParam, lParam );

    switch ( message ) {
    case WM_INITDIALOG:
        if ( 0 == lParam ) {
            makeResizable( hwnd, &g_resizer );
        } else {
            makeResizable2( hwnd, IDC_EDIT );
            if ( 2 == lParam ) {
                setBehavior( hwnd, IDC_COMBO      , right, none );
                setBehavior( hwnd, IDC_STATIC_TEXT, both , both );
            }
        }
        return TRUE; //*** FUNCTION EXIT POINT
    case WM_COMMAND:
        if ( IDOK == id || IDCANCEL == id ) {
            if ( BN_CLICKED == code ) {
                EndDialog( hwnd, id );
            }
        }
        return TRUE; //*** FUNCTION EXIT POINT
    }
    return FALSE;    //*** FUNCTION EXIT POINT
}

#pragma warning( disable: 4100 ) // unreferenced formal parameter

int WINAPI _tWinMain( HINSTANCE h, HINSTANCE h2, LPSTR p, int n ) {
    LPARAM i;
    fixDefBtns();
    for ( i = 0; i < 3; ++i ) {
        DialogBoxParam( h, MAKEINTRESOURCE( IDD_RESIZE_SAMPLE ), 
            HWND_DESKTOP, resizeDlgProc, i );
    }
    return 0;
}
