#if !defined(_NODE_SUBSCRIBER_H)
#define _NODE_SUBSCRIBER_H

#include "publish.h"

class CTreeNode; // Subject class

// Subscriber class
class CNodeSubscriber
{
public:
    virtual void OnNodeUpdate (CTreeNode *) {}
    virtual void OnNodeDelete (CTreeNode *) {}
    virtual void OnNodeCopy (CTreeNode *, CTreeNode *) {}
};

// Publisher class
class CNodePublisher: public CEventPublisher <CNodeSubscriber>
{
public:
    enum nodeEventType {eUPDATE, eDELETE, eCOPY};

    CNodePublisher () {
        AddEvent (eUPDATE);
        AddEvent (eDELETE);
        AddEvent (eCOPY);
        }

    void PublishNodeUpdate (CTreeNode *n) {
        IMPLEMENT_PUBLISHER (eUPDATE, OnNodeUpdate (n))
        }
    void PublishNodeDelete (CTreeNode *n) {
        IMPLEMENT_PUBLISHER (eDELETE, OnNodeDelete (n))
        }
    void PublishNodeCopy (CTreeNode *a, CTreeNode *b) {
        IMPLEMENT_PUBLISHER (eCOPY, OnNodeCopy (a, b))
        }
};
#endif