// CTreeNode - subject class
class CTreeNode : public CObject, public CNodePublisher
{
    :
    // Publish delete notification when removing child nodes
    RemoveChild (CTreeNode *child) {
        PublishNodeDelete (child);
        :
        }
    // Publish update notification when changing the name
    SetName (LPCSTR name) {
        :
        PublishNodeUpdate (this);
        }
    :
};

// CMyPropSheet - observer class
class CMyPropSheet : public CPropertySheet, public CNodeSubscriber
{
    CTreeNode *m_focus;

public:
    // Call SetFocusNode to unsubscribe
    ~CMyPropSheet () {SetFocusNode (NULL);}

    // Handle Subscribe and Unsubscribe whenever 
    // the focus node changes.
    void SetFocusNode (CTreeNode *node) {
        if (m_focus)
            m_focus->UnSubscribeAll (this);
        m_focus = node;
        if (m_focus) {
            m_focus->Subscribe (this, eDELETE);
            m_focus->Subscribe (this, eUPDATE);
            }
        }

    // Handle delete event
    virtual void OnNodeDelete (CTreeNode *node) {
        if (node == m_focus) 
            SetFocusNode (NULL);
        }

    // Handle apply button pressed message
    void OnApply() {
        :
        m_pFocusNode->UnSubscribe (this, CNodePublisher::eUPDATE);
        BOOL success = ApplyPages ();
        m_pFocusNode->Subscribe (this, CNodePublisher::eUPDATE);
        :
        }

}

};

